import java.io.*;
import java_cup.runtime.*;
import node.*;
import env.*;
import grammar.*;
import text.*;

public class Main {

	public static void main( String[] argv ) {
		String dirName = null;

		try {
			for ( int i = 0; i < argv.length; i++ ) {
				if ( argv[ i ].equals( "-debug" ) ) {
					Print.DEBUG = true;
					}
				else if ( argv[ i ].equals( "-dir" ) ) {
					i++;
					if ( i >= argv.length )
						throw new Error( "Missing directory name" );
					dirName = argv[ i ];
					}
				else {
					throw new Error( 
						"Usage: java Main [-debug] -dir directory" );
					}
				}

			if ( dirName == null )
				throw new Error( "Directory not specified" );

			System.setErr( new PrintStream( new FileOutputStream( 
				new File( dirName, "program.parse" ) ) ) );
			Print.setError( new File( dirName, "program.err" ) );
			Print.setReprint( new File( dirName, "program.print" ) );
			Print.setCompile( new File( dirName, "usercode.user.s" ) );

			parser p = new parser( new File( dirName, "program.in" ) );
			ProgramNode program;
			if ( Print.DEBUG )
				program = ( ProgramNode ) p.debug_parse().value;
			else
				program = ( ProgramNode ) p.parse().value;
			Print.error().println( "Reprinting ... " );
			Print.reprint().println( program );
			Print.error().println( "Generate Code ... " );
			program.genCode();
			
			}
		catch ( Exception e ) {
			Print.error().println( "Exception at " );
			e.printStackTrace();
			}
		}
	}

