package node;

import env.*;
import code.*;
import node.stmtNode.*;

import java.util.*;

public class ProgramNode extends Node {

	private StmtListNode stmtList;
	
	public ProgramNode( StmtListNode stmtList ) {
		this.stmtList = stmtList;
		}
	
	public String toString() {
		return "" + stmtList;
		}
		
	public void genCode() {
		Env env = new Env();
		Code.instrn( "entry", "main.enter" );
		Code.importFile( "../../IMPORT/callsys.h" );
		Code.importFile( "../../IMPORT/proc.h" );
		Code.importFile( "../../IMPORT/callsys.lib.s" );
		Code.importFile( "../../IMPORT/string.lib.s" );
		Code.importFile( "../../IMPORT/number.lib.s" );
		Code.importFile( "../../IMPORT/io.lib.s" );

		Code.enterBlock( "main", null, null );

		Code.enter( "data" );
		stmtList.genDeclCode( env );
		Code.exit( "data" );
		
		Code.enter( "code" );
		Code.publicLabelDefn( "enter" );
		stmtList.genCode();
		Code.instrn( "clr", "$a0" );
		Code.instrn( "bsr", "Sys.exit.enter" );
		Code.exit( "code" );

		Code.exitBlock( "main" );
		}
	}
