package node.exprNode;

import node.*;

public abstract class ExprNode extends Node {

	protected final static int PREC_ASSIGN	=	0;
	protected final static int PREC_OR		=	1;
	protected final static int PREC_AND		=	2;
	protected final static int PREC_NOT		=	3;
	protected final static int PREC_REL		=	4;
	protected final static int PREC_ADD		=	5;
	protected final static int PREC_MUL		=	6;
	protected final static int PREC_PRIMARY	=	7;

	protected int precedence;

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "( " + toString() + " )";
		else
			return toString();
		}

	public abstract void evalCode( int freeReg );

	}
