package node.exprNode.binaryNode;

import env.*;
import code.*;
import node.exprNode.*;

public abstract class BinaryNode extends ExprNode {

	protected String operator;
	protected String opCode;
	protected ExprNode left, right;

	public BinaryNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		}
		
	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public void evalCode( int freeReg ) {
		left.evalCode( freeReg );
		right.evalCode( freeReg + 1 );
		Code.instrn( opCode, 
			Code.tempReg( freeReg ), Code.tempReg( freeReg + 1 ) );
		}
	}
