package node.stmtNode;

import env.*;
import code.*;

import node.exprNode.*;

public class WhileStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode stmt;

	public WhileStmtNode( ExprNode cond, StmtNode stmt ) {
		this.cond = cond;
		this.stmt = stmt;
		}

	public String toString() {
		return "while " + cond + " do%+%n" + stmt + "%-";
		}

	public void genDeclCode( Env env ) {
		stmt.genDeclCode( env );
		}
		
	public void genCode() {
		Code.enter();
		Code.labelDefn( "while" );
		cond.evalCode( 0 );
		Code.instrn( "blbc", "$t0", "end" );
		Code.labelDefn( "do" );
		stmt.genCode();
		Code.instrn( "br", "while" );
		Code.labelDefn( "end" );
		Code.exit();
		}

	}
